#include "extension.h"

bool StrEqual(const char *pStr1, const char *pStr2)
{
	if(pStr1 && pStr2) return stricmp(pStr1, pStr2) == 0;
	return false;
}


int CFilter::GetRecipientCount(void) const
{
	return m_Recipients.Count();
}


int CFilter::GetRecipientIndex(int iSlot) const
{
	if(iSlot < 0 || iSlot >= GetRecipientCount())
		return -1;

	return m_Recipients[iSlot];
}


bool CFilter::IsInitMessage(void) const
{ 
	return false;
}


bool CFilter::IsReliable(void) const
{
	return false;
}


void CFilter::Add(int iIndex)
{
	if(m_Recipients.Find(iIndex) != m_Recipients.InvalidIndex())
		return;

	m_Recipients.AddToTail(iIndex);
}


void CFilter::AddAll(void)
{
	edict_t *pEntity;

	for(int i = 1; i <= g_SMAPI->pGlobals()->maxClients; i++)
	{
		if(!(pEntity = engine->PEntityOfEntIndex(i)) || pEntity->IsFree())
			continue;

		if(!StrEqual("player", pEntity->GetClassName()) || StrEqual("bot", engine->GetPlayerNetworkIDString(pEntity)))
			continue;

		m_Recipients.AddToTail(i);
	}
}


void CFilter::RemoveAll(void)
{
	m_Recipients.RemoveAll();
}